Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 88)
@@ -32,40 +32,61 @@
     log_printf(FUNC,Counter,"Counter","Begin");
 
-#ifdef SYSTEMC
+#if DEBUG_Counter == true
+    log_printf(INFO,Counter,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << param << std::endl;
+#endif    
+
+    log_printf(INFO,Core,FUNCTION,_("<%s> Allocation"),_name.c_str());
     allocation ();
-#endif
 
 #ifdef STATISTICS
-    // Allocation of statistics
-    statistics_declaration(param_statistics);
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Core,FUNCTION,_("<%s> Allocation of statistics"),_name.c_str());
+
+        // Allocation of statistics
+        statistics_declaration(param_statistics);
+      }
 #endif
 
 #ifdef VHDL
-    // generate the vhdl
-    vhdl();
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Core,FUNCTION,_("<%s> Generate the vhdl"),_name.c_str());
+	
+        vhdl();
+      }
 #endif
 
 #ifdef SYSTEMC
 
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    SC_METHOD (transition);
-    dont_initialize ();
-    sensitive << (*(in_CLOCK)).pos();
+	log_printf(INFO,Core,FUNCTION,_("<%s> Method - transition"),_name.c_str());
+
+        SC_METHOD (transition);
+        dont_initialize ();
+        sensitive << (*(in_CLOCK)).pos();
 #endif
 
-    SC_METHOD (genMealy);
-    dont_initialize ();
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      sensitive << *(in_COUNTER_DATA   [i])
-		<< *(in_COUNTER_ADDSUB [i]);
-
+	log_printf(INFO,Core,FUNCTION,_("<%s> Method - genMealy"),_name.c_str());
+        SC_METHOD (genMealy);
+        dont_initialize ();
+        for (uint32_t i=0; i<_param._nb_port; i++)
+          sensitive << *(in_COUNTER_DATA   [i])
+                    << *(in_COUNTER_ADDSUB [i]);
+        
 #ifdef SYSTEMCASS_SPECIFIC
-    // List dependency information
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      {
-	(*(out_COUNTER_DATA [i])) (*(in_COUNTER_DATA   [i]));
-	(*(out_COUNTER_DATA [i])) (*(in_COUNTER_ADDSUB [i]));
+        // List dependency information
+        for (uint32_t i=0; i<_param._nb_port; i++)
+          {
+            (*(out_COUNTER_DATA [i])) (*(in_COUNTER_DATA   [i]));
+            (*(out_COUNTER_DATA [i])) (*(in_COUNTER_ADDSUB [i]));
+          }
+#endif    
       }
-#endif    
 
 #endif
@@ -76,11 +97,15 @@
   {
     log_printf(FUNC,Counter,"~Counter","Begin");
-#ifdef SYSTEMC
-    deallocation ();
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+        delete _stat;
+      }
 #endif
 
-#ifdef STATISTICS
-    delete _stat;
-#endif
+    log_printf(INFO,Core,FUNCTION,_("<%s> Deallocation"),_name.c_str());
+    deallocation ();
+
     log_printf(FUNC,Counter,"~Counter","End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 88)
@@ -1,7 +1,6 @@
-#ifdef SYSTEMC
 /*
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
@@ -29,5 +28,5 @@
     _interfaces = entity->set_interfaces();
 
-    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
       Interface * interface = _interfaces->set_interface(""
@@ -43,5 +42,5 @@
     }
 
-    // ~~~~~[ Interface : "counter" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "counter" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
         in_COUNTER_DATA  = new SC_IN (Tdata_t)    * [_param._nb_port];
@@ -64,9 +63,11 @@
 	 }
      }
+
 #ifdef POSITION
-    _component->generate_file();
+     if (usage_is_set(_usage,USE_POSITION))
+       _component->generate_file();
 #endif
 
-    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     log_printf(FUNC,Counter,"allocation","End");
   };
@@ -77,3 +78,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 88)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 /*
  * $Id$
@@ -19,11 +18,14 @@
     log_printf(FUNC,Counter,"deallocation","Begin");
 
-    delete     in_CLOCK;
-    delete     in_NRESET;
-    
-    delete []  in_COUNTER_DATA  ;
-    delete []  in_COUNTER_ADDSUB;
-    delete [] out_COUNTER_DATA  ;
-    
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        delete     in_CLOCK;
+        delete     in_NRESET;
+        
+        delete []  in_COUNTER_DATA  ;
+        delete []  in_COUNTER_ADDSUB;
+        delete [] out_COUNTER_DATA  ;
+      }
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
@@ -38,3 +40,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_end_cycle.cpp	(revision 88)
@@ -20,5 +20,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -26,5 +27,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp	(revision 88)
@@ -25,13 +25,13 @@
   };
   
-  Parameters::Parameters (Parameters & param):
-    _size_data(param._size_data),
-    _nb_port  (param._nb_port  ),
-    _data_max (param._data_max )
-  {
-    log_printf(FUNC,Counter,"Parameters","Begin");
-    test();
-    log_printf(FUNC,Counter,"Parameters","End");
-  };
+//   Parameters::Parameters (Parameters & param):
+//     _size_data(param._size_data),
+//     _nb_port  (param._nb_port  ),
+//     _data_max (param._data_max )
+//   {
+//     log_printf(FUNC,Counter,"Parameters","Begin");
+//     test();
+//     log_printf(FUNC,Counter,"Parameters","End");
+//   };
 
   Parameters::~Parameters () 
@@ -41,7 +41,12 @@
   };
 
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Counter,"copy","Begin");
+    log_printf(FUNC,Counter,"copy","End");
+  };
+
 }; // end namespace counter
 }; // end namespace generic
-
 }; // end namespace behavioural
 }; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libPriority.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.deps	(revision 88)
@@ -0,0 +1,37 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Priority			= yes
+ifndef Common
+include 			$(DIR_MORPHEO)/Common/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Priority_DIR			=	$(DIR_MORPHEO)/Behavioural/Generic/Priority
+
+#-----[ Library ]------------------------------------------
+
+Priority_LIBRARY		= 	-lPriority\
+					$(Common_LIBRARY)	
+
+Priority_DIR_LIBRARY		=	-L$(Priority_DIR)/lib\
+					$(Common_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Priority_library		:
+				@\
+				$(MAKE) --directory=$(Priority_DIR) --makefile=Makefile;\
+				$(MAKE) Common_library;
+
+Priority_library_clean	:
+				@\
+				$(MAKE) --directory=$(Priority_DIR) --makefile=Makefile clean;\
+				$(MAKE) Common_library_clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Priority_LIBRARY)
+
+DIR_LIBRARY			= $(Priority_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Priority_library
+
+library_clean			: Priority_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_mono_gpr.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_mono_gpr.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_mono_gpr.cfg	(revision 88)
@@ -0,0 +1,6 @@
+Priority
+0	1	+1	# priority      
+0	1	+1	# load_balancing
+1	1	+1	# nb_grp                 
+1	16	*4	# nb_elt         [0] [nb_grp]
+1	1	+1	# nb_grp_select          
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_multi_gpr.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_multi_gpr.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/config_multi_gpr.cfg	(revision 88)
@@ -0,0 +1,9 @@
+Priority
+0	1	+1	# priority      
+0	1	+1	# load_balancing
+4	4	+1	# nb_grp                 
+4	4	*4	# nb_elt         [0] [nb_grp]
+1	1	*4	# nb_elt         [1] [nb_grp]
+16	16	*4	# nb_elt         [2] [nb_grp]
+2	2	*4	# nb_elt         [3] [nb_grp]
+1	4	+1	# nb_grp_select          
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,24 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Generic/Priority/include/Priority.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::generic;
+using namespace morpheo::behavioural::generic::priority;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,102 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/SelfTest/include/test.h"
+
+#define NB_PARAMS 4
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * priority                (Tpriority_t      )\n"));
+  err (_(" * load_balancing          (Tload_balancing_t)\n"));
+  err (_(" * nb_grp                  (uint32_t         )\n"));
+  err (_(" * nb_elt         [nb_grp] (uint32_t         )\n"));
+  err (_(" * nb_grp_select           (uint32_t         )\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc <= static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name = argv[x++];
+  Tpriority_t       _priority       = fromString<Tpriority_t      >(argv[x++]);
+  Tload_balancing_t _load_balancing = fromString<Tload_balancing_t>(argv[x++]);
+
+  uint32_t          _nb_grp         = fromString<uint32_t         >(argv[x++]);
+
+  if (argc != static_cast<int>(2+NB_PARAMS+_nb_grp))
+    usage (argc, argv);
+
+  uint32_t        * _nb_elt = new uint32_t [_nb_grp];
+  for (uint32_t i=0; i<_nb_grp; i++)
+    _nb_elt [i] = fromString<uint32_t>(argv[x++]);
+
+  uint32_t          _nb_grp_select  = fromString<uint32_t         >(argv[x++]);
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      Priority * _Priority = new Priority 
+	(name.c_str(),
+	 _priority,
+	 _load_balancing,
+	 _nb_grp       ,
+	 _nb_elt       ,
+	 _nb_grp_select);
+      
+      _Priority->reset();
+
+
+      std::list<select_t> * select;
+
+      for (uint32_t i=0; i<32; i++)
+	{
+	  msg("Iteration [%d]\n",i);
+	  _Priority->transition();
+	  select = _Priority->select();
+	  for (std::list<select_t>::iterator it = select->begin();
+	       it != select->end();
+	       it ++)
+	    {
+	      msg("  - [%d] %d\n",(*it).grp, (*it).elt);
+	    }
+	}
+
+      delete _Priority;
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Priority : no error");
+      else
+	TEST_KO("Priority : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  return (_return);
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/doc/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/doc/Makefile	(revision 88)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Priority.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Priority.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Priority.h	(revision 88)
@@ -0,0 +1,98 @@
+#ifndef morpheo_behavioural_generic_priority_Priority_h
+#define morpheo_behavioural_generic_priority_Priority_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/include/Types.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+#include <list>
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace priority {
+
+
+  class Priority 
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected: const std::string   _name          ;
+  private  : Tpriority_t         _priority      ;
+  private  : Tload_balancing_t   _load_balancing;
+  private  : uint32_t            _nb_grp        ;
+  private  : uint32_t          * _nb_elt        ;//[nb_grp]
+  private  : uint32_t            _nb_grp_select ;
+  private  : uint32_t            _max_nb_elt    ;
+
+  private  : void (morpheo::behavioural::generic::priority::Priority::*reset_priority           ) (void);
+  private  : void (morpheo::behavioural::generic::priority::Priority::*reset_load_balancing     ) (void);
+
+  private  : void (morpheo::behavioural::generic::priority::Priority::*transition_priority      ) (void);
+  private  : void (morpheo::behavioural::generic::priority::Priority::*transition_load_balancing) (void);
+
+  private  : uint32_t            reg_GRP_PRIORITY;
+  private  : std::list<select_t> _select;
+
+    // -----[ method ]----------------------------------------------------
+  public  :           Priority (std::string       name,
+				Tpriority_t       priority      ,
+				Tload_balancing_t load_balancing,
+				uint32_t          nb_grp        ,
+				uint32_t        * nb_elt        ,//[nb_grp]
+				uint32_t          nb_grp_select
+				);
+  public  :           Priority (std::string       name,
+				Tpriority_t       priority      ,
+				uint32_t          nb_grp        ,
+				uint32_t          nb_grp_select
+				);
+
+  public  :           Priority (std::string       name,
+				Tpriority_t       priority      ,
+				uint32_t          nb_grp        
+				);
+
+  public  :          ~Priority (void);
+
+  public  : void     allocation                                     (void);
+  public  : void     deallocation                                   (void);
+					       
+  public  : void     reset                                          (void);
+  public  : void     transition                                     (void);
+
+  public  : void     reset_priority_none                            (void);
+  public  : void     reset_priority_static                          (void);
+  public  : void     reset_priority_round_robin                     (void);
+
+  public  : void     reset_load_balancing_none                      (void);
+  public  : void     reset_load_balancing_priority_only             (void);
+  public  : void     reset_load_balancing_balance                   (void);
+  public  : void     reset_load_balancing_maximum_for_priority      (void);
+
+  public  : void     transition_priority_none                       (void);
+  public  : void     transition_priority_static                     (void);
+  public  : void     transition_priority_round_robin                (void);
+
+  public  : void     transition_load_balancing_none                 (void);
+  public  : void     transition_load_balancing_priority_only        (void);
+  public  : void     transition_load_balancing_balance              (void);
+  public  : void     transition_load_balancing_maximum_for_priority (void);
+
+  public  : std::list<select_t> * select (void);
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Types.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/include/Types.h	(revision 88)
@@ -0,0 +1,36 @@
+#ifndef morpheo_behavioural_generic_priority_Types_h
+#define morpheo_behavioural_generic_priority_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace priority {
+
+  class select_t
+  {
+  public : uint32_t grp ;
+  public : uint32_t elt;
+    
+  public : select_t (uint32_t grp,
+		     uint32_t elt)
+    {
+      this->grp = grp;
+      this->elt = elt;
+    }
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority.cpp	(revision 88)
@@ -0,0 +1,101 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/include/Priority.h"
+#include "Common/include/Max.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace priority {
+  
+#undef  FUNCTION
+#define FUNCTION "Priority::Priority"
+  Priority::Priority (std::string       name,
+		      Tpriority_t       priority      ,
+		      Tload_balancing_t load_balancing,
+		      uint32_t          nb_grp        ,
+		      uint32_t        * nb_elt        ,//[nb_grp]
+		      uint32_t          nb_grp_select
+		      ):
+    _name              (name)
+  {
+    log_begin(Priority,FUNCTION);
+
+    _priority       = priority      ;
+    _load_balancing = load_balancing;
+    _nb_grp         = nb_grp        ;
+    _nb_elt         = nb_elt     ;
+    _nb_grp_select  = nb_grp_select ;
+    _max_nb_elt     = max<uint32_t>(_nb_elt,_nb_grp);
+
+    allocation();
+
+    log_end(Priority,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Priority::Priority"
+  Priority::Priority (std::string       name,
+		      Tpriority_t       priority      ,
+		      uint32_t          nb_grp        ,
+		      uint32_t          nb_grp_select
+		      ):
+    _name              (name)
+  {
+    log_begin(Priority,FUNCTION);
+
+    _priority       = priority   ;
+    _load_balancing = LOAD_BALANCING_MAXIMUM_FOR_PRIORITY;
+    _nb_grp         = nb_grp     ;
+//  _nb_elt         = nb_elt     ;
+    _nb_grp_select  = nb_grp_select ;
+    _max_nb_elt     = 1;
+
+    allocation();
+
+    log_end(Priority,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Priority::Priority"
+  Priority::Priority (std::string       name,
+		      Tpriority_t       priority      ,
+		      uint32_t          nb_grp        
+		      ):
+    _name              (name)
+  {
+    log_begin(Priority,FUNCTION);
+
+    _priority       = priority   ;
+    _load_balancing = LOAD_BALANCING_MAXIMUM_FOR_PRIORITY;
+    _nb_grp         = nb_grp     ;
+//  _nb_elt         = nb_elt     ;
+    _nb_grp_select  = nb_grp     ;
+    _max_nb_elt     = 1;
+
+    allocation();
+
+    log_end(Priority,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Priority::~Priority"
+  Priority::~Priority (void)
+  {
+    log_begin(Priority,FUNCTION);
+
+    deallocation ();
+
+    log_end(Priority,FUNCTION);
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_allocation.cpp	(revision 88)
@@ -0,0 +1,70 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/include/Priority.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace priority {
+  
+#undef  FUNCTION
+#define FUNCTION "Priority::allocation"
+  void Priority::allocation (void)
+  {
+    log_begin(Priority,FUNCTION);
+    
+    if (_nb_grp == 1)
+      {
+	reset_priority      = &morpheo::behavioural::generic::priority::Priority::reset_priority_none     ;
+	transition_priority = &morpheo::behavioural::generic::priority::Priority::transition_priority_none;
+      }
+    else
+      switch (_priority)
+	{
+	case PRIORITY_STATIC      : {reset_priority      = &morpheo::behavioural::generic::priority::Priority::reset_priority_static          ;
+	                             transition_priority = &morpheo::behavioural::generic::priority::Priority::transition_priority_static     ;
+				     break;}
+	case PRIORITY_ROUND_ROBIN : {reset_priority      = &morpheo::behavioural::generic::priority::Priority::reset_priority_round_robin     ;
+	                             transition_priority = &morpheo::behavioural::generic::priority::Priority::transition_priority_round_robin;
+				     break;}
+	default: {throw ERRORMORPHEO(FUNCTION,_("Unknow Priority scheme.\n"));}
+	}
+
+    if ((_max_nb_elt == 1) and (_nb_grp_select == 1))
+      {
+	reset_load_balancing      = &morpheo::behavioural::generic::priority::Priority::reset_load_balancing_none;
+	transition_load_balancing = &morpheo::behavioural::generic::priority::Priority::transition_load_balancing_none;
+      }
+    else
+      {
+	if (_max_nb_elt == 1)
+	  {
+	    reset_load_balancing      = &morpheo::behavioural::generic::priority::Priority::reset_load_balancing_priority_only;
+	    transition_load_balancing = &morpheo::behavioural::generic::priority::Priority::transition_load_balancing_priority_only;
+	  }
+	else
+	  switch (_load_balancing)
+	    {
+	    case LOAD_BALANCING_BALANCE              : {reset_load_balancing      = &morpheo::behavioural::generic::priority::Priority::reset_load_balancing_balance                  ;
+                                                        transition_load_balancing = &morpheo::behavioural::generic::priority::Priority::transition_load_balancing_balance             ;
+							break;}
+	    case LOAD_BALANCING_MAXIMUM_FOR_PRIORITY : {reset_load_balancing      = &morpheo::behavioural::generic::priority::Priority::reset_load_balancing_maximum_for_priority     ;
+                                                        transition_load_balancing = &morpheo::behavioural::generic::priority::Priority::transition_load_balancing_maximum_for_priority;
+							break;}
+	    default: {throw ERRORMORPHEO(FUNCTION,_("Unknow Load Balancing scheme.\n"));}
+	    }
+      }
+    
+
+    log_end(Priority,FUNCTION);
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_deallocation.cpp	(revision 88)
@@ -0,0 +1,27 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/include/Priority.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace priority {
+  
+#undef  FUNCTION
+#define FUNCTION "Priority::deallocation"
+  void Priority::deallocation (void)
+  {
+    log_begin(Priority,FUNCTION);
+    
+    log_end(Priority,FUNCTION);
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_reset.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_reset.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/src/Priority_reset.cpp	(revision 88)
@@ -0,0 +1,30 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Priority/include/Priority.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace priority {
+  
+#undef  FUNCTION
+#define FUNCTION "Priority::reset"
+  void Priority::reset (void)
+  {
+    log_begin(Priority,FUNCTION);
+
+    (this->*reset_priority      ) ();
+    (this->*reset_load_balancing) ();
+    
+    log_end(Priority,FUNCTION);
+  };
+
+}; // end namespace priority
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
